# Author: Jerome Tuengler, Henri Gruender

#include <unistd.h> 					// sleep
#include <pxauto.h>				 		// pixtend auto
#include <pthread.h> 					// multithreading
#include <string.h> 					// strings
#include <stdio.h>						// 
#include <stdlib.h>						// 
#include <time.h> 						// Zeit
#include <arpa/inet.h> 					// internet
#include <sys/socket.h> 				// 

#define abbrechenGedrueckt 0
#define pinKorrekt 1	
#define pinFalsch 2	
#define superPinEingegeben 3
#define bOK 10
#define bCA 11	
#define bNONE 12
#define MAXBUF 1024
#define DELIM "="

#define PORT 5259   			// The port on which to listen for incoming data
char recipient[MAXBUF];
char mailString[MAXBUF]; 
char picString[MAXBUF];

int superPin = 9998;
int usleep_delay = 5500;
int opentimerangemin = 2;
int opentimerangemax = 58;

int eingabeAuswerten();			
int compButton(int,int);
void init();
void schlossOeffnen();
void schlossSchliessen();
void tonAusgeben(int);
void eMailSchicken();
void sperren();
void foto();
void nextLED();
void get_config(char *);

pthread_t cheese;
pthread_t email;
pthread_t UDP;
pthread_t sound;
int pin = 1234;
int anzahlFehleingaben = 0;
int wartezeit;
int eingabe = 0;
int i = 0;
time_t t;
struct tm * ts;
struct pixtIn InputData;
struct pixtOut OutputData;
struct pixtOutDAC OutputDataDAC;
char bildZahl[] = {"000"};
char neuePin = 0;
char udpbuf[4];
char udpready = 0;
char photoState = 0;
int numPosition;
int datePosition;
int timePosition;

void* playSound5(void *arg) {
	OutputData.wPwm0 = 100; 
	usleep(80000);
	OutputData.wPwm0 = 65535; 
	return NULL;
}

void* waitForUDP(void *arg) {
	struct sockaddr_in si_me, si_other;
	int s, i;
	unsigned int slen = sizeof(si_other);
	char buf[4];
    s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    memset((char *) &si_me, 0, sizeof(si_me));
    si_me.sin_family = AF_INET;
    si_me.sin_port = htons(PORT);
    si_me.sin_addr.s_addr = htonl(INADDR_ANY);
    bind(s , (struct sockaddr*)&si_me, sizeof(si_me));
    while(1)
    {
        fflush(stdout);
        recvfrom(s, buf, 4, 0, (struct sockaddr*) &si_other, &slen);
		if(strcmp ((inet_ntoa(si_other.sin_addr)),("127.0.0.1")) == 0){
			while(udpready == 1);
			for(i = 0; i <= 3; i++){
				udpbuf[i] = buf[i];
			}
			udpready = 1;
			for(i = 0; i <= 3; i++){
				buf[i] = 0;
			}
		}
    }
}

void* sendEmail(void *arg) {
	t = time(NULL);
	ts = localtime(&t);
	mailString[datePosition] = ((ts->tm_mday) / 10) + 48;
	mailString[datePosition + 1] = ((ts->tm_mday) % 10) + 48;
	mailString[datePosition + 2] = '.';
	mailString[datePosition + 3] = ((ts->tm_mon+1) / 10) + 48;
	mailString[datePosition + 4] = ((ts->tm_mon+1) % 10) + 48;
	mailString[datePosition + 5] = '.';
	mailString[timePosition] = ((ts->tm_hour) / 10) + 48;
	mailString[timePosition + 1] = ((ts->tm_hour) % 10) + 48;
	mailString[timePosition + 2] = ':';
	mailString[timePosition + 3] = ((ts->tm_min) / 10) + 48;
	mailString[timePosition + 4] = ((ts->tm_min) % 10) + 48;
	system(mailString);
	return NULL;
}

void* takePhoto(void *arg) {
	photoState = 1;
	system(picString);
	photoState = 0;
	return NULL;
}

int autoMode() {
	Spi_AutoMode(&OutputData, &InputData);
	Spi_AutoModeDAC(&OutputDataDAC);
	return(0);
}

int main(int argc, char *argv[]) {
	Spi_Setup(0);
	get_config("/etc/acs/acs.conf");
	init();
	pthread_create(&(UDP), NULL, &waitForUDP, NULL);
	autoMode();
	usleep(usleep_delay);
	while (1) {
		eingabe = eingabeAuswerten();
		switch(eingabe) {
			case abbrechenGedrueckt:
				break;
			case pinKorrekt:
				tonAusgeben(0);
				usleep(usleep_delay);
				schlossOeffnen();
				sleep(wartezeit);
				anzahlFehleingaben = 0;
				tonAusgeben(1);
				usleep(usleep_delay);
				schlossSchliessen();
				usleep(usleep_delay);
				break;
			case pinFalsch:
				OutputData.byDigOut = 16;
				tonAusgeben(2); 
				usleep(usleep_delay);
				foto();
				if(anzahlFehleingaben < 2) { 
					anzahlFehleingaben ++; 
				} else { 
					tonAusgeben(3); 
					eMailSchicken(); 
					sperren(); 
					anzahlFehleingaben = 0; 
				} 
				OutputData.byDigOut = 0;
				autoMode();
				usleep(usleep_delay);
				break;
			case superPinEingegeben:
				tonAusgeben(4);
				usleep(usleep_delay);				
				foto();
				neuePin = 1; 
				OutputData.byDigOut = 24;
				autoMode();
				usleep(usleep_delay);
				break;
			default: 
				foto();
				break;
		}
	}
	return(0);
}

int eingabeAuswerten() {
	int isButtonPressedC1 = 0;
	int isButtonPressedC2 = 0;
	int isButtonPressedC3 = 0;
	int digits[] = {0,0,0,0};
	int currentDigit = 0;
	int currentInput = 0;
	int pressedButton = 0;
	int fin = 0;
	while(fin == 0){
		OutputData.byDigOut &= 56;
		OutputData.byDigOut |= 1;
		autoMode();
		for (i = 0; i < 500000; i++);
		currentInput = InputData.byDigIn;
		if (currentInput == 15){
			isButtonPressedC1 = 0;
		}
		if (currentInput != 15 && isButtonPressedC1 == 0) {
			isButtonPressedC1 = 1;
			pressedButton = compButton(currentInput, 1);
			switch (pressedButton) {
				case 10:
					fin = 1;
					OutputData.byGpioOut = 0;
				case 12:
					break;
				default:
					if(currentDigit <= 3) digits[currentDigit] = pressedButton;
					currentDigit++;
					nextLED();
					usleep(usleep_delay);
					tonAusgeben(5);
					usleep(usleep_delay);
			}
		}
		OutputData.byDigOut &= 56;
		OutputData.byDigOut |= 2;
		autoMode();
		for (i = 0; i < 500000; i++);
		currentInput = InputData.byDigIn;
		if (currentInput == 15){
			isButtonPressedC2 = 0;
		}
		if (currentInput != 15 && isButtonPressedC2 == 0) {
			isButtonPressedC2 = 1;
			pressedButton = compButton(currentInput, 2);
			switch (pressedButton) {
				case 12:
					break;
				default:
					if(currentDigit <= 3) digits[currentDigit] = pressedButton;
					currentDigit++;
					nextLED();
					usleep(usleep_delay);
					tonAusgeben(5);
					usleep(usleep_delay);
			}
		}
		OutputData.byDigOut &= 56;
		OutputData.byDigOut |= 4;
		autoMode();
		for (i = 0; i < 500000; i++);
		currentInput = InputData.byDigIn;
		if (currentInput == 15){
			isButtonPressedC3 = 0;
		}
		if (currentInput != 15 && isButtonPressedC3 == 0) {
			isButtonPressedC3 = 1;
			pressedButton = compButton(currentInput, 3);
			switch (pressedButton) {
				case 11:
					tonAusgeben(5);
					usleep(usleep_delay);
					OutputData.byGpioOut = 0;
					OutputData.byDigOut = 0;
					neuePin = 0;
					autoMode();
					usleep(usleep_delay);
					return abbrechenGedrueckt;
				case 12:
					break;
				default:
					if(currentDigit <= 3) digits[currentDigit] = pressedButton;
					currentDigit++;
					nextLED();
					usleep(usleep_delay);
					tonAusgeben(5);
					usleep(usleep_delay);
			}
		}
		if(udpready == 1){
			for(i = 0; i <= 3; i++){
				digits[i] = udpbuf[i] - 48;
			}
			udpready = 0;
			fin = 1;
		}
	}
	if(neuePin){
		if(((digits[0] * 1000) + (digits[1] * 100) + (digits[2] * 10) + digits[3]) == superPin || ((digits[0] * 1000) + (digits[1] * 100) + (digits[2] * 10) + digits[3]) == 0 ){
			tonAusgeben(2);
			return abbrechenGedrueckt;
		}
		pin = (digits[0] * 1000) + (digits[1] * 100) + (digits[2] * 10) + digits[3];
		neuePin = 0;
		usleep(usleep_delay);	
		tonAusgeben(4);
		usleep(usleep_delay);	
		OutputData.byDigOut = 0;
		autoMode();
		usleep(usleep_delay);
		return abbrechenGedrueckt;
	}
	if(((digits[0] * 1000) + (digits[1] * 100) + (digits[2] * 10) + digits[3]) == 0){
		wartezeit = ((((InputData.rAi0 * (2430 * (opentimerangemax-opentimerangemin))))/6000) + opentimerangemin);
		printf("%d Sekunden\n", wartezeit);
		return abbrechenGedrueckt;
	}
	if (((digits[0] * 1000) + (digits[1] * 100) + (digits[2] * 10) + digits[3]) == pin) {
		return pinKorrekt;
	}
	if (((digits[0] * 1000) + (digits[1] * 100) + (digits[2] * 10) + digits[3]) == superPin) {
		return superPinEingegeben;
	}
	return pinFalsch;
}

int compButton(int row, int col) {
	switch (row) {
		case 7: return col;
		case 11: return (col + 3);
		case 13: return (col + 6);
		case 14:
			switch (col) {
				case 1: return bOK;
				case 2: return 0;
				case 3: return bCA;
				default: break;
			}
		default: break;
	}
	return bNONE;
}

void get_config(char *filename) {
		char asuperPin[MAXBUF];
		char ausleep_delay[MAXBUF];
		char amailString[MAXBUF];
		char arecipient[MAXBUF];
		char aopentimerangemin[MAXBUF];
		char aopentimerangemax[MAXBUF];
		char apicString[MAXBUF];
        FILE *file = fopen (filename, "r");
        if (file != NULL) {
			char line[MAXBUF];
			int i = 0;
			while(fgets(line, sizeof(line), file) != NULL) {
				char *cfline;
				cfline = strstr((char *)line,DELIM);
				
				if((cfline != 0) && (line[0] != '#')) {
					cfline = cfline + strlen(DELIM);
					if (i == 0) {
							memcpy(asuperPin,cfline,strlen(cfline));
					} else if (i == 1) {
							memcpy(ausleep_delay,cfline,strlen(cfline));
					} else if (i == 2) {
							memcpy(amailString,cfline,strlen(cfline));
					} else if (i == 3) {
							memcpy(arecipient,cfline,strlen(cfline));
					} else if (i == 4) {
							memcpy(aopentimerangemin,cfline,strlen(cfline));
					} else if (i == 5) {
							memcpy(aopentimerangemax,cfline,strlen(cfline));
					} else if (i == 6) {
							memcpy(apicString,cfline,strlen(cfline));
					}
					i++;
				}
			}
        }
        fclose(file);
        superPin = atoi(asuperPin);
		usleep_delay = atoi(ausleep_delay);
		
		strncpy(mailString, amailString, strlen(amailString) - 2);
		strncpy(recipient, arecipient, strlen(arecipient) - 2);
		
		opentimerangemin = atoi(aopentimerangemin);
		opentimerangemax = atoi(aopentimerangemax);
		strncpy(picString, apicString, strlen(apicString) - 2);

		char speter[MAXBUF] = ("echo -e \"");
		char nachher[MAXBUF] = ("\" |msmtp --file=/home/pi/.msmtprc ");
		strcat(speter, mailString);
		strcat(speter, nachher);
		strcat(speter, recipient);
		strcpy(mailString,speter);
		char * sfound = strstr(mailString,"[date]");
		char * ssfound = strstr(mailString,"[h-m]");
		datePosition = sfound - mailString;
		timePosition = ssfound - mailString;
		
		char secretstringvariable[MAXBUF] = ("raspistill -hf -vf -n -o ");
		strcat(secretstringvariable,picString);
		strcpy(picString,secretstringvariable);
		char * found = strstr(picString,"[n]");
		numPosition = found - picString;
}

void init() {
	OutputData.byGpioOut = 0;
	OutputDataDAC.wAOut0 = 0;
	OutputDataDAC.wAOut1 = 0;
	OutputData.byDigOut = 0;
	OutputData.byRelayOut = 0;
	OutputData.wPwm0 = 65535;
	OutputData.wPwm1 = 0;
	OutputData.byPwm0Ctrl0 = 1;
	OutputData.byPwm0Ctrl1 = 1;
	OutputData.byPwm0Ctrl2 = 1;
	OutputData.byGpioCtrl = 15;
	OutputData.byUcCtrl = 16;
	OutputData.byAiCtrl0 = 0;
	OutputData.byAiCtrl1 = 0;
	OutputData.byAux0 = 0;
}

void schlossOeffnen() {
	OutputData.byDigOut = 8;
	OutputData.byRelayOut = 1;
	autoMode();
	wartezeit = (InputData.rAi0 * 23) + 2;
}

void schlossSchliessen() {
	OutputData.byDigOut = 0;
	OutputData.byRelayOut = 0;
	autoMode();
}

void tonAusgeben(int ton) {
	switch(ton){
		case 0: //geöffnet
			OutputData.wPwm0 = 100; 
			autoMode(); 
			for (i = 0; i < 10000000; i++); 
			OutputData.wPwm0 = 65535; 
			autoMode(); 
			break;
		case 1: //geschlossen
			OutputData.wPwm0 = 100; 
			autoMode(); 
			for (i = 0; i < 5000000; i++); 
			OutputData.wPwm0 = 65535; 
			autoMode(); 
			break;
		case 2: //pin falsch
		case 3: //pin 3 mal falsch
			OutputData.wPwm0 = 100; 
			autoMode(); 
			for (i = 0; i < 5000000; i++); 
			OutputData.wPwm0 = 65535; 
			autoMode(); 
			for (i = 0; i < 2000000; i++); 
			OutputData.wPwm0 = 100; 
			autoMode(); 
			for (i = 0; i < 5000000; i++); 
			OutputData.wPwm0 = 65535; 
			autoMode(); 
			break;
		case 4: //super pin
			OutputData.byPwm0Ctrl0 = 1; 
			OutputData.byPwm0Ctrl1 = 2; 
			OutputData.byPwm0Ctrl2 = 2; 
			OutputData.wPwm0 = 100; 
			autoMode(); 
			for(i = 0; i < 5000000; i++);
			OutputData.byPwm0Ctrl0 = 1; 
			OutputData.byPwm0Ctrl1 = 1; 
			OutputData.byPwm0Ctrl2 = 1; 
			OutputData.wPwm0 = 100; 
			autoMode(); 
			for(i = 0; i < 5000000; i++); 
			OutputData.wPwm0 = 65535;			
			autoMode(); 
			break;
		case 5: //taste betätigt
			pthread_create(&(sound), NULL, &playSound5, NULL);
			break;
	}
}

void eMailSchicken() {
	pthread_create(&(email), NULL, &sendEmail, NULL);
}

void sperren() {
	OutputData.byDigOut = 16;
	autoMode();
	for(i = 0; i <= 10; i++){
		sleep(30);
		foto();
	}
}

void foto() {
	if(photoState == 0){
		system("who > /home/pi/bildlog.log");
		picString[numPosition] = bildZahl[0];
		picString[numPosition + 1] = bildZahl[1];
		picString[numPosition + 2] = bildZahl[2];
		pthread_create(&(cheese), NULL, &takePhoto, NULL);
		if(bildZahl[2] == '9'){
			bildZahl[2] = '0';
			if(bildZahl[1] == '9'){
				bildZahl[1] = '0';
				if(bildZahl[0] == '9'){
					bildZahl[0] = '0';
				} else {
					bildZahl[0]++;
				}
			} else {
				bildZahl[1]++;
			}
		}
		else {
			bildZahl[2]++;
		}
	}
}

void nextLED(){ 
	switch(OutputData.byGpioOut){
		case 0: 
			OutputData.byGpioOut = 1; 
			//autoMode(); 
			//usleep(usleep_delay); 
			break;
		case 1: 
			OutputData.byGpioOut = 3; 
			//autoMode(); 
			//usleep(usleep_delay);
			break;
		case 3: 
			OutputData.byGpioOut = 7;
			//autoMode();
			//usleep(usleep_delay);
			break;
		case 7:
			OutputData.byGpioOut = 15;
			//autoMode();
			//usleep(usleep_delay);
			break;
		default: break;
	}
}
